#ifndef motifclusterrun_include_declared
#define motifclusterrun_include_declared

#include "libClust.h"
#include "FastaIO.h"
#include "exceptions.h"
#include "Cluster.h"
#include "GFFWriter.h"
#include "PWMIO.h"

class MotifClusterRun{

  private:
  // variables
  InstanceSet * _pAllInstances;
  int _C1; // total loaded data (detected motifs)
  GFFWriter * _pOutText;
  GFFWriter * _pDebugText;
  // results
  list<Cluster*>* _pClusterResults;
  int _nbrClusters;
  // for storing the data-information
  vector<string*> *_pAllData;
  int _minSeqVolume;
  int _minDataVolume;
  
  public:
  // constructor
  MotifClusterRun();
  
  // destructor
  ~MotifClusterRun();

  // input 
  void LinkoutputText(GFFWriter * pGffout, GFFWriter * pGffdebug){_pOutText = pGffout; _pDebugText = pGffdebug; return;};
  void LoadInstances(string * file);
  void DatasetDimension(const double &pCut, const double &iCut, const double &jCut);

  // main cluster functions
  bool ClusterXnodesYdata(const double &mCut,const double &minCS);

  // output
  void PrintClusters();
  void PrintMotifs(PWMIO * matrixIO);
};


#endif
