#ifndef exceptions_include_declared
#define exceptions_include_declared

#include "inclusive.h"
#include "GFFWriter.h"

// here all exception handler classes are defined  
// that will be used in try-catch exception handling

class ErrorInputfiles{
  public:
    ErrorInputfiles(string message, GFFWriter * report)
    { cerr << "--Error in input: " <<  message << endl;
      ostringstream cerrstr;   
      cerrstr << "--Error in input: " <<  message << endl;  
      report->AddComment(cerrstr.str());
      cerrstr.flush(); // flush  
    };
};
class InputDimension{
  public: 
    InputDimension(string message, GFFWriter * report)
    { cerr << "--Error not enough input: " << message << endl;
      ostringstream cerrstr;   
      cerrstr << "--Error not enough input: "<<  message << endl;  
      report->AddComment(cerrstr.str());
      cerrstr.flush(); // flush  
    };
};
class InvalidInput{
  public: 
    InvalidInput(string message, GFFWriter * report)
    { cerr << "--Warning skip invalid input: " << message << endl;
      ostringstream cerrstr;   
      cerrstr << "--Warning skip invalid input: "<<  message << endl;  
      report->AddComment(cerrstr.str());
      cerrstr.flush(); // flush  
    };
};
//class Skip{
//};
class AbortSampling{
  public: 
    AbortSampling(string message)
    {cerr << "--Abort in sampling: " << message << endl;};
};
class AbortMasking{
  public: 
    AbortMasking(string message)
    {cerr << "--Abort in masking: " << message << endl;};
};


#endif
